﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using OpenLibSys;

namespace cpuid
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            uint eax=0;
            uint ebx=0;
            uint ecx=0;
            uint edx=0;

            Ols ols = new Ols();

            // Check support library sutatus
            switch (ols.GetStatus())
            {
                case (uint)Ols.Status.NO_ERROR:
                    break;
                case (uint)Ols.Status.DLL_NOT_FOUND:
                    MessageBox.Show("Status Error!! DLL_NOT_FOUND");
                    Environment.Exit(0);
                    break;
                case (uint)Ols.Status.DLL_INCORRECT_VERSION:
                    MessageBox.Show("Status Error!! DLL_INCORRECT_VERSION");
                    Environment.Exit(0);
                    break;
                case (uint)Ols.Status.DLL_INITIALIZE_ERROR:
                    MessageBox.Show("Status Error!! DLL_INITIALIZE_ERROR");
                    Environment.Exit(0);
                    break;
            }

            ols.Cpuid(0, 0, ref eax, ref ebx, ref ecx, ref edx);

            string name = "";
            name += Convert.ToChar((byte)((ebx & 0x000000FF) >>  0)).ToString();
            name += Convert.ToChar((byte)((ebx & 0x0000FF00) >>  8)).ToString();
            name += Convert.ToChar((byte)((ebx & 0x00FF0000) >> 16)).ToString();
            name += Convert.ToChar((byte)((ebx & 0xFF000000) >> 24)).ToString();
            name += Convert.ToChar((byte)((edx & 0x000000FF) >>  0)).ToString();
            name += Convert.ToChar((byte)((edx & 0x0000FF00) >>  8)).ToString();
            name += Convert.ToChar((byte)((edx & 0x00FF0000) >> 16)).ToString();
            name += Convert.ToChar((byte)((edx & 0xFF000000) >> 24)).ToString();
            name += Convert.ToChar((byte)((ecx & 0x000000FF) >>  0)).ToString();
            name += Convert.ToChar((byte)((ecx & 0x0000FF00) >>  8)).ToString();
            name += Convert.ToChar((byte)((ecx & 0x00FF0000) >> 16)).ToString();
            name += Convert.ToChar((byte)((ecx & 0xFF000000) >> 24)).ToString();
             
            ProcessorName.Content = name;
        }
    }
}
